--KEYS=============
local keyReset = "R"
local keySaveState = "T"
--KEYS=============

--ADDRESS=============
local adrRoomPosition = 0x0151
local adrTimer = 0x0023
--ADDRESS=============

local keyState = 0
local timerState = 0 --0 = NotStarted, 1 = Running, 2 = Ended
local frames = 0

local roomPosition = 0

local savedState = nil

--Conditions to start the timer
function timerStartCondition()
	if not (memory.readbyte(adrRoomPosition) == roomPosition) then
		roomPosition = memory.readbyte(adrRoomPosition)
		timerState = 1
	end
end

--Know when to end the timer
function timerEndCondition()
	if not (memory.readbyte(adrRoomPosition) == roomPosition) then
		timerState = 2
	end
end

--Reset Attempt
function reset()
	frames = 0
	timerState = 0
	savestate.load(savedState)
	roomPosition = memory.readbyte(adrRoomPosition)
end

--Set SaveState
function setSaveState()
	savedState = savestate.object()
	savestate.save(savedState)
	reset()
end

--Get the position of the value as if it was AnchorRight (Because the built in on does not work?)
function getPosAnchorRight(basePos, value)
	return basePos - (string.len(tostring(value)) * guiFontSize)
end

--GUI Elements
function updateGUI()
	--Timer activated
	if timerState > 0 then
		
		local posX = 20
		local posY = 212
		gui.text(posX, posY, frames)
	end
end

--Keys
function updateKeys()
	local inputs = input.get()
	
	if keyState == 0 then
		--Reset
		if inputs[keyReset] then
			if savedState == nil then
			
			else
				keyState = 1
				reset()
				return
			end
		end
		
		--Set SaveState
		if inputs[keySaveState] then
			keyState = 1
			setSaveState()
			return
		end
		
	elseif not inputs[keyReset] == true and not inputs[keySaveState] == true then
		keyState = 0
	end
end

----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
setSaveState()

while true do
	--0 = NotStarted
	if timerState == 0 then
		timerStartCondition()
	--1 = Running
	elseif timerState == 1 then
		frames = frames + 1
		timerEndCondition()
	--2 = Ended
	elseif timerState == 2 then
		--Nothing
	end
	
	memory.writebyte(adrTimer, 1)
	
	updateKeys()
	updateGUI()
	emu.frameadvance()
end