;This contains ONLY variables for the games

;;;;;;;;;;;;;;;;;;;;;;;;;;
;NES and MAPPER Specifics;
;;;;;;;;;;;;;;;;;;;;;;;;;;
vPPUCONTROL = $2000	;PPU Control
vPPUMASK = $2001	;PPU Mask
vPPUSTATUS = $2002	;PPU Status
vOAMADDR = $2003
vOAMDATA = $2004
vPPUSCROLL = $2005
vPPUADDR = $2006	;Address to use for next vPPUDATA read/write
vPPUDATA = $2007
vOAMDMA = $4014
;Audio
vAPU_PULSE1[4] = $4000
vAPU_PULSE2[4] = $4004
vAPU_TRIANGLE[4] = $4008
vAPU_NOISE[4] = $400C
vAPU_DMC[4] = $4010
vAPU_STATUS = $4015
;vAPU_FRAME_COUNTER = $4017 ;Disable for now, I want to see the JOYPAD values
vJOYPAD[2] = $4016	;Joypad :Warning, $2017 is also used for APU_FRAME_COUNTER
vBANKSELECT = $8000	;Which bank to modify next vBANKDATA affectation
vBANKDATA = $8001	;Which bank to use

;;;;;;;;;;;;;;
;Game Context;
;;;;;;;;;;;;;;
vGameContext = $0000 ;Main context of the game
;00 = Overworld? (Default State, not assign?)
;01 = Overworld
;02 = Dialog with full screen character
;03 = In Dungeon
;81 = Scene Transition to Overworld
;82 = Scene Transition to Dialog
;83 = Scene Transition to Dungeon
;84 = Reload Dungeon Checkpoint And remove 1 Live (from Dungeon Only)
;85 = End Game Credit (from Dungeon Only)
;86-FF = Same as 85 (Not tested them all)
vGameState = $0003 ;State of the game, are state of current action to do
;00 = Playing
;05 = Paused
;02 = Walking toward room transition or trought wall
;0D = Request a Scene Transition (From dungeon only?) (Used in relation with $0149)
;11 = Done walking toward room transition
;12 = Start Mike jump for transition
;12 ALSO = About Each frame loading 1 row of tile (top to bottom)
;13 = Mike jump peak height for transition
;14 = Remove Mike sprite (and probably enemies too)
;15 = ? Remove some screen stuff?
;16	= ? Remove some screen stuff?
;21 = Camera moving in between the 2 rooms
;23 = Mike reapearing with the second half of the jump
;24 = ?
;29 = Mike landing
;2A = (8 frames) Load and Spawn each enemies group (4 groups)?
vLoadingState? = $0021 ;Seems to manage what loading is currently being processed
;$00 = No loading
;$01 = Pre-Loading / Small loading
;$FF = Big Loading (Enter Dungeon, Enter Village, ...)
;$02 to $7F = Crash/Make the game be stuck
vChapterNumber = $0005 ; Current chapter reached
vChapterSubSection? = $0130 ;Progress of current chapter... Not always linear... Or maybe temporary sub section reached?

vRNGInput = $001F ;Each frame this value is incremented in relation to the combined inputs value
;$01 = Right
;$02 = Left
;$04 = Down
;$08 = Up
;$10 = Start
;$20 = Select
;$40 = B
;$80 = A
vBankSelectionDataBuffer[6] = $0140 ;Seems to be a buffer for bank selection used at 0F:9A39

;Is reduced by 1 each frame then loop and repeat forever!!!
vGameTimer100 = $0023

;;;;;;;
;Input;
;;;;;;;
vInputValue = $00D0 ;Combine Value of each button down
;$01 = Right
;$02 = Left
;$04 = Down
;$08 = Up
;$10 = Start
;$20 = Select
;$40 = B
;$80 = A
vInputCrossValue = $00D2 ;Inputs value for only the cross pressed
;$01 = Right
;$02 = Left
;$04 = Down
;$08 = Up
;$05 = Right-Down
;$06 = Left-Down
;$09 = Right-Up
;$0A = Left-Up
vInputCross = $00D3			;$00 = Idle, $01 = Pressed (Any Direction), $81 = Buffering (Any Direction)
vInputAValue = $00DE		;$00 OR $80
vInputA = $00D5				;$00 = Idle, $01 = Pressed, $81 = Buffering
vInputBValue = $00D6		;$00 OR $40
vInputB = $00D7				;$00 = Idle, $01 = Pressed, $81 = Buffering
vInputStartValue = $00D8	;$00 OR $10
vInputStart = $00D9			;$00 = Idle, $01 = Pressed, $81 = Buffering
vInputSelectValue = $00DA	;$00 OR $20
vInputSelect = $00DB		;$00 = Idle, $01 = Pressed, $81 = Buffering


;The code that read inputs does it 4 times, not sure why...
;More info at the code at : 0F:87EC
;For Controller0, the values are stored at $01C2,$01C4,$01C6,$01C8
;For Controller1, the values are stored at $01C3,$01C4,$01C6,$01C9
;Each bits is an input, if 1 = true, if 0 = false for each bits
vInputNESController[8] = $01C2

;;;;;;;
;Audio;
;;;;;;;
;NOTE: A lot of audio stuffs seems to be at the PRG RAM $7000-$7FFF
vMusicNumberToPlay? = $00A1 ;Seems to be the next music to start playing, or somthing like that
vMusicSpeed = $04B6 ;Smaller = Faster
vMusicTrack? = $04C9 ;?Very old personal note, I did not put more comment in the pass...TODO :Confirm
vMusicTrack?? = $04CC ;?Very old personal note, I did not put more comment in the pass...TODO :Confirm
;TODO : Get the official tracks name....
;Dungeon			$00 or $04
;Overworld			$01
;ChiefTalk			$02
;Village			$03
;Boss				$05
;EndOfChapter		$06
;Chapter4			$07
;Ruins1				$08
;StartChapter		$09
;Chapter3Crash		$0A
;MainScrenMusic		$0B
;OverworldSub		$0C
;Death				$0D
;Mystery			$0E
;GameOver			$0F
;ShipSinkChapt5		$10
;BeatBossVictory	$11
;Parrot				$12
;HealedGirlChapt3	$13
;Chapter3Crash2		$14
;In Sub				$15
;BeforeBoss			$16
;CaptainSongPiano	$17
;AlienDungeon		$18
;UncleTalk?			$19
;CreditPart2		$1A
;SheColaChief		$1B
;AlienOverworl		$1C
;Ruins2				$1D
;SavedSpecies		$1E
;CreditPart1		$1F
;SheColaOverworld	$20
;IntroHelicopter	$21
;SpaceShipFly1		$22
;SpaceShipFly2		$23
;I think it stop here, random giberish after that
;seems like to loop at 80

;Play a sound, if multiple sound are played at the same time
;The sound with the highest priority will play and not the other
;Each sound priority have their unique sound list, they are not all the same
;Maybe therecis a Ptr pointing to which bank of sound that it use, idk
vSoundPriority0 = $00A2
;00000000
;|||||||-- ButtonActivated
;||||||--- ChestOpening
;|||||---- DoorClosing
;||||----- WallExploding
;|||------ CantRememberWhatIsExactly?
;||------- BossScreaming
;|-------- CantRememberWhatIsExactly1?
;--------- CantRememberWhatIsExactly2?
vSoundPriority1 = $00A3
;00000000
;|||||||-- Baseball Bat Swing
;||||||--- SuperNova
;|||||---- Yoyo
;||||----- Shooting Star
;|||------ Pick Up Item (Start, Hp, Hearth, etc)
;||------- Enemy Hit
;|-------- Small Enemy Exploding
;--------- Player Get Hit
vSoundPriority2 = $00A4
;00000000
;|||||||-- Magma/Mud Enemy diving in water/lava
;||||||--- 3 Tile Jump (With the shoes)
;|||||---- Jump End (The sound when a jump finish)
;||||----- Normal Jump
;|||------ Alien Gun Shot
;||------- WaterFall (in C3-5)
;|-------- Item Switch (Pressing Select)
;--------- CantRememberWhatIsExactly3?


;;;;;;;;;;
;Graphics;
;;;;;;;;;;
vPPUPaletteBufferFlag = $01C0 ;Flag if need to update Palette
;If >= $80 (last bit is set) = Update at 0F:84A7
vPPUPaletteBuffer[20] = $01A0 ;Buffer to update PPU Palette

vSprite[100] = $0200 ;Sprites variables (Y, No, Attributes, X)
;TODO : Player Mike sprite somewhere here, since I this it is hardcoded which on it use
;Since it is always in priority to be shown over other sprites
vPPUTileBufferFlagSomething? = $050D ;Flag for tile buffer or something related? (Used at function 0D:AF94)
vPPUTileBufferFlagSomething2? = $052E ;Flag for tile buffer or something related? (Used at function 0D:AF94)
vPPUTileBufferFlagOne = $050E ;Flag if need to update Tile from buffer
;If >= $80 (last bit is set) = Update at 0F:83CC
vPPUTileBuffer[46] = $052F ;Buffer to update PPU Tile,
;Seems to be able to hold up to $46 (If we refer to 0D:AF94)
;Used also for 0F:83CC (UpdatePPUTileFromBufferV0)


vPPUAttributeBufferFlag = $050F ;Flag to know if Attribute Buffer need to be updated to the PPU
;00000000
;||||||||
;|||||||?
;||||||--- 1:Apply buffer for first name table   0:don't
;|||||---- 1:Apply buffer for second name table  0:don't
;?????
vPPUAttributeBuffer[80] = $0580 ;Buffer attribute first and second nametable
;vPPUAttributeBufferAt23C0[40] = $0580 ;Buffer attribute first nametable
;vPPUAttributeBufferAt27C0[40] = $05C0 ;Buffer attribute second nametable

;--------------------
;Buffer Configuration
;--------------------
;<0>[byte] => ptrHi for vPPUADDR
;<1>[byte] => ptrLo for vPPUADDR
;<2>[byte] => Amount of tiles + Direction
;00000000
;||||||||
;|-------- Amount of tiles : $00 to $7F)
;--------- Direction : 0 = Left to Right, 1 = Up to Bottom
;<3>:[bytes] => Tiles value (as many byte as the amount retreived)
;<4>:[byte] => ptrHi for vPPUADDR (If $00 : quit) (Else go at <1>)
;--------------

;;;;;;;;
;Camera;
;;;;;;;;
vCameraPositionX = $0013
vCameraPositionXMulti = $0014
vCameraPositionY = $0015
vCameraPositionYMulti = $0016

;;;;;;;;
;Player;
;;;;;;;;
vPlayerControlState? = $0030 ;Some sort of state that limit the player control over Mike
;$00 = Paused
;$04 = Disable, Door Opening,
;$06 = Disable, Room Transition, Secret Wall Transition, Cenematic... (Enable Switch Slot, Probably is another variables) 
;$07 = Enable
vPlayerMovementLag = $0031
;Prevent the player to walk for "X" frames.
;Reduced by 1 each frame when ON THE GROUND
;Changing direction from the CENTER of a tile = $08
;Changing direction mid movement = $10
;Changing direction mid movement AND going this direction = $05 (Is 11 but is instantly reduced to 5)
;Changing direction mid jump = $05
;Changing DIRECTION and JUMP at the same frame, does not change the value
;Entering a new room = $04
vPlayerPositionX = $0032
;In overworld, is offset by $08
vPlayerPositionXMulti = $0033
vPlayerPositionY = $0034
;In overworld, is offset by $08, loop each $F0 instead of each $100
vPlayerPositionYMulti = $0035
vPlayerDirectionJump = $0036 ; Direction of the current jump 
;NOTE: If done in between 2 tiles while walking, the direction can change
;in relation to the next direction to walk toward.
vPlayerDirectionUnknown? = $0037 ;Seems to be a direction, but for what?
vPlayerDirectionFacing = $0038 ;Direction that Mike is facing
;For all Direction
;0 = Down
;1 = Up
;2 = Right
;3 = Left

vPlayerHurtBoxState = $003B ;State to know if Mike can get hit
;00000000
;||||||||
;||||||--- 01 = Grounded, 02 = Mid-Jump (First Half - Going Up), 03 = Mid-Jump (Second Half - Going Down)
;|||||---- 04 = ?
;||||----- 08 = ?
;|||------ 10 = ?
;||------- 20 = Going Throught Wall (Seems to be Invincible too)
;|-------- 40 = ? (Seems to be Invincible too)
;--------- 80 = Invincible (EX : When Getting hit)
;NOTE : They can be combined
;EX : 81 = Grounded and Invincible
vPlayerActionState = $0040 ;NOTE : This is not the only variable that say which state mike is currently
;Direction : 00 = Down, 01 = Up, 02 = Right, 03 = Left
;+ 04 => Idle
;+ 08 => Walking
;+ 0C => Walking on place (EX : When you walk in a wall)
;+ 10 => Jump on place
;+ 14 => Jump 1 tile
;+ 18 => Jump 2 tiles
;+ 1C => Jump 3 tiles (With the Anklet)
;+ 28 => Attack with Yoyo Animation
;+ 2C => Jump-Attack (No matter the distance)
;+ 30 => Room transition
;+ 38 => Waling throught wall transition
;+ 3C => Waling throught wall (EX D8-1 Room 2)
;+ 60 => Attack with Gun Animation
;+ 64 => Jump-Attack with Gun Animation
vPlayerMovementPixelSpeed = $0052 ;How many pixel to move this frame
vPlayerMovementPixelReached = $0053 ;Current pixel when Walking between 2 tiles.
;00 to 0F
;Used to know how much pixel to move next time with data stored at 0D:$A821
;If data retreived is $02, it will move by 2 pixel next frame, etc
;Warning : Modifying the data for walk speed often just won't work correctly...
vPlayerAnimationAttack? = $0065 ;Animation to use
;00 = Animation from Ground
;01 = Animation from First Half Jump
;02 = Animation from Second Half Jump
vPlayerMaxHearthAmount = $0111 ;$01 Hearth = $02 HP (Seems the only way to know MAX HP)
vPlayerCurrentHP = $0112

vPlayerHPToLooseBuffer = $016A ;Change this value to loose HP (No Sound)
vPlayerHPToGainBuffer = $016D ;Change this value to gain HP (No Sound)


vPlayerLiveAmount = $0117
vPlayerStarAmount = $011C
vPlayerPotionAmount = $012C
;Tile value for visual update
;If last bit is set ($>=80, it means it need to be updated
vPlayerLiveAmountTileValue = $0166
vPlayerStarAmountTileValue = $0164
vPlayerPotionAmountTileValue = $0163


vPlayerSlotSelected = $014B ;Use this slot ammo when attacking
vPlayerSlotAvailible[4] = $0120 ;$00 = false, $01 = true
vPlayerSlotSomething?[4] = $0124 ;Seems to be slot stuff still
vPlayerSlotAmmo[4] = $0128 ;#$00 to $63
vPlayerSlotSomething2?[4] = $012C ;Seems to be slot stuff still

vPlayerHaveAnkletBoots = $0180 ;For 3 tiles jump : 0 = false, 1 = true
vPlayerNextAttackType = $0182 ;To know what type of attack it will do
vPlayerMainWeaponDamage = $0185 ;Yoyo, Shooting State and Super Nova, but for the DIRECT CONTACT
;The projectile damage is not stored in RAM it seems? More investigation needed.
vPlayerAttackLagMulti = $018E; Prevent the player from attacking (Ex Fuzzy ball in C6-2 ($3C * $06))
vPlayerAttackLag = $018F ;Prevent the player from attacking (Ex Fuzzy ball in C6-2 ($3C * $06))
vPlayerShirtColor = $01BF ;Mike shirt color.
;$21 Blue Normal
;$27 Orange Special Boots
vPlayerJumpLag = $0768 ;Prevent the player from jumping for "X" frames.
;Ending a jump = #04
;Reduced by 1 each frame when ON THE GROUND
vPlayerAttackPrevent? = $0778 ;TODO : Test again, since there is another variable for that, that is similar...



;;;;;;;
;Enemy;
;;;;;;;
vEnemyPositionX[6] = $00C4
vEnemyPositionXMulti?[6] = $031E
vEnemyPositionY[6] = $00CA
vEnemyCollisionSpecification?[6] = $0324 ;Collision
;00000000
;||||||||
;|||||||-- ?
;|||||---- Can hit the Player only when : 0 = On Ground, 1 On Ground OR Second Half of Jump, 2 = Always, 3 ?
;--------- ? (If set to $7F, it seems to instant kill enemies)
vEnemyCollisionSizeAndGraphics?[6] = $032A ;Seems to affect collision size and which graphics to use.
;Range : $00 to $15, more then that, it normaly crash
;$0C => C-Serpent use it
vEnemyHP[6] = $0330 ;If >= $80, the enemy is invincible (Not hit stun when hit)
vEnemyDirectionFacing?[6] = $033C ;Need to re-test, my initial note only say direction
vEnemyState?[6] = $03A2 ;Some action state, or etc? 0 = dead?
;Maybe it is Enemy number, like 1 is maybe Octot, 2 is etc...
vEnemyDamageOnContact[6] = $0408


;;;;;;;;;
;Dungeon;
;;;;;;;;;
;For all those flags, start at $01, then fo to $FF when done, sometime it is set to 2 tought, TODO : More investigation
vDungeonProgressFlag[10] = $0790
;vDungeonFlagC1D1_Progress = $0790 
;vDungeonFlagC2D1_Progress = $0791
;vDungeonFlagC3D1_Progress = $0792
;vDungeonFlagC3D3_Progress = $0794
;vDungeonFlagC3D2_Progress = $0793
;vDungeonFlagC3D4_Progress = $0795
;vDungeonFlagC3D?_Progress? = $0796 ;Does not seems used for anything?
;vDungeonFlagC3D5_Progress = $0797
;vDungeonFlagC5D1_Progress = $0798
;vDungeonFlagC6DExtra_Progress = $0799 ;The mini-transition (Just walk forward)
;vDungeonFlagC6D1_Progress = $079A
;vDungeonFlagC6D2_Progress = $079B
;vDungeonFlagC7D1_Progress = $079C
;vDungeonFlagC7D2_Progress = $079D
;vDungeonFlagC8D?_Progress? = $079E ;Does not seems used for anything?
;vDungeonFlagC8D1_Progress = $079F


vDungeonSceneTransitionTo = $0149 ;Which scene to transition to
;80 (Entry) (From the entry point) Walk Transition
;81 (Success) (Finished dungeon) Walk Transition
;82 (Wrong Exit0) (EX : Used for Ghost Village) Walk Transition
;83 (Wrong Exit1) (EX : Used for Ghost Village) Walk Transition
;40 (Teleporter Animation) then go to 50
;41 (Teleporter Animation) then go to 51
;42 (Teleporter Animation) then go to 52
;43 (Teleporter Animation) then go to 53
;50	(Teleporter0) If present in room
;51 (Teleporter1) If present in room
;52 (Teleporter2) If present in room
;53 (Teleporter3) If present in room
vDungeonTileUnderPlayerPtrLo = $0039 ;ptr Tile under Mike when finishing walk, jump, etc
vDungeonTileUnderPlayerPtrHi = $003A ;ptr Tile under Mike when finishing walk, jump, etc
vDungeonTile[13F] = $0600 ;It is a $20 by $0A grid (32x10).
;IMPORTANT : The top row is graphicly there, but does not containt tiles values
;            Which is why it IS NOT (32x11)
;Start from Top-Left and move to the right
;Sometime, a random tile is used for other data (Boss State, etc)


;TODO : Check if they are used only for RESPAWN or SPAWN as well.
vDungeonRespawnRoom = $014A ;Room to Load When Reloading a Checkpoint
vDungeonRespawnPositionXPosition = $0099
vDungeonRespawnPositionXMulti? = $009A ;Not checked, this is only a guess for big room
vDungeonRespawnPositionY = $009B; Position Y to respawn
vDungeonRespawnPositionYMulti? = $009C ;Not checked, this is only a guess (Should not be used actualy, since no big room on Y axis)
vDungeonRespawnDirectionFacing = $009D ;Facing direction when respawning



;;;;;;
;Room;
;;;;;;
;Room values seems to be about $40 bytes long
;Might also contains some enemies stuff or etc
;Since at code 0F:E57D, it clear all of it
vRoomLocationRight? = $0150 ;Something related to room
;If $FF => SingleRoom? if not, it is a 2 screen room..? (or something related)
vRoomLocationLeft = $0151 ;Room value
;Going Up = +$08
;Going Down = -$08
;Going Right = +$01
;Going Left = -$01
vRoomUNKNOWN0 = $0152 ;Seems to be room location for right side (so it is always vRoomLocationLeft + 1?
vRoomLayoutRight = $0153 ;What layout to use for the right side (for large room)
vRoomLayoutLeft = $0154 ;What layout to use for the left side (for large room) and for solo screen room
;Room Data are splitted in 2 sections
;For Chapter 1 to 6, Room layout range is [$00 to $63]
;For Chapter 7 to 8, Room layout range is [$00 to $3F]
vRoomSettings = $0155 ;Not sure if I should call it RoomSettings but...
;Can Set : Special blocks trigger
;Can Set : Sprites color palette
;Can Set : Tiles color pallete
;Can Set : Sprites (Chr Bank)
;Can Set : Music
;Can Set : etc?...
;Can Set : Special item placement, HP Packs, Weapons, Anklet, etc
;Can Set : Explodable wall that can now be walkable
;Can Set : Progress condition (Which enemies count to kill)
vRoomValueUNKNOWN4? = $0156 ;
vRoomEnemySpawnLayout = $0157 ;Where is each enemies going to spawn at
;When in C1-1, Max 28, TODO : OTHERS Dungeon
vRoomEnemyTypeList = $0158 ;List of enemies to spawn
;Limit 79 it seems? it CAN work after that.. but it seems to crash often randomly

vRoomLoadingLineBufferAffectationCount = $00ED ;How many time to add current tile configuration to the buffer
vRoomLoadingLineBufferIndex = $050C ;This index of the LineBuffer
vRoomLoadingLineBuffer[10] = $0510 ;When loading a Room, it does it Line by Line (so $10 Tile)
;This contains the values for the offset that will lead in setting the Ptr $EE_$EF
;From this Ptr, it will then lead to which Tile Value to load




;;;;;;;;;;;;;;;;;;;;;;;
;Other/To order better;
;;;;;;;;;;;;;;;;;;;;;;;
;Seems to be the current banks value used
vCurrentBanksUsed? = $000C

;Is probably more then only 2, but for now, it is what I know are MOST LIKELY temp
vTemporary[2] = $00F0

;$10 bytes in the RAM that say : STARTROPICS  RD3
;Which is : 53 54 41 52 54 52 4F 50 49 43 53 20 20 52 44 33
;As far as I know for now, they are never used for anything
;NOTE: Data for it stored in the ROM at : 0x000E00A
vSTARTROPICS__RD3[10] = $0100




